#![doc = include_str!("../README.md")]
#![forbid(unsafe_code)]
#![feature(backtrace)]

mod sealed;
pub(crate) use sealed::seal;

mod context;
pub use context::{Context, IntoContext};

mod report;
pub use report::{Report, ReportOpts};

mod into;
pub(crate) use into::IntoResultHow;

mod explain;
pub use explain::Explain;

#[cfg(feature = "termination")]
mod termination;
#[cfg(feature = "termination")]
pub use termination::TerminationResult;

mod how;
pub use self::how::How;

pub type Result<T, E = How> = std::result::Result<T, E>;
